/**********************************************************************
 * 
 * $Id: draw_dialog.c,v 1.4 2000/05/04 01:17:02 htran Exp $
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 **********************************************************************/

#include <errno.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include "signal_callbacks.h"

char *get_information(char *data);
extern GtkWidget *mpegVideoCLIST, *otherVideoCLIST;
extern pthread_mutex_t playingLock;

static void 
dismiss_button_clicked(GtkWidget *w,gpointer data);

GtkWidget *more_info;

GtkWidget *draw_dialog(char *title,char *contact,char *data, int flag){

  char videoPlaying=0;
  
  GtkWidget *dismiss_button;
  GtkWidget *dialog;
  
  GtkWidget *hbox,*textbox,*vscrollbar,*frame;
  GtkWidget *stop_button,*play_button;
  GtkWidget *title_label;
  GtkWidget *label;
  
  GtkWidget *frame_vbox;
  GtkWidget *audio_checkbox, *video_checkbox, *zoom_checkbox;
  
  dialog=gtk_dialog_new();
  gtk_window_set_title(GTK_WINDOW(dialog),title);
  gtk_window_set_default_size(GTK_WINDOW(dialog),400,100);
  dismiss_button = gtk_button_new_with_label("Dismiss");
  
  //gtk_signal_connect_object(GTK_OBJECT (dismiss_button), "clicked",
  //								 GTK_SIGNAL_FUNC (gtk_widget_destroy),
  //								 GTK_OBJECT(dialog));
  gtk_signal_connect(GTK_OBJECT (dismiss_button), "clicked",
							GTK_SIGNAL_FUNC(dismiss_button_clicked),
							dialog);
  
  gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->action_area),
                     dismiss_button);
  /* stop button */
  stop_button=gtk_button_new_with_label("Stop");
  gtk_container_add(GTK_CONTAINER (GTK_DIALOG(dialog)->action_area),
                    stop_button);
  
  /* play button */
  play_button=gtk_button_new_with_label("Play");
  gtk_container_add(GTK_CONTAINER (GTK_DIALOG(dialog)->action_area),
						  play_button);
  
  /* check boxes. */
  audio_checkbox=gtk_check_button_new_with_label("Audio");
  gtk_container_add(GTK_CONTAINER (GTK_DIALOG(dialog)->action_area),
                    audio_checkbox);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(audio_checkbox),1);
  
  video_checkbox=gtk_check_button_new_with_label("Video");
  gtk_container_add(GTK_CONTAINER (GTK_DIALOG(dialog)->action_area),
                    video_checkbox);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(video_checkbox),1);
  
  zoom_checkbox=gtk_check_button_new_with_label("Zoom");
  gtk_container_add(GTK_CONTAINER (GTK_DIALOG(dialog)->action_area),
                    zoom_checkbox);
  /* title label */
  title_label = gtk_label_new (title);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),
                     title_label,FALSE,FALSE,0);
  
  /* horizontal box for text box and scroll bar */
  hbox=gtk_hbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),hbox,TRUE,TRUE,0);
  textbox=gtk_text_new(NULL,NULL);
  gtk_text_set_editable(GTK_TEXT(textbox),FALSE);
  gtk_text_set_word_wrap(GTK_TEXT(textbox),TRUE);
  gtk_box_pack_start(GTK_BOX(hbox),textbox,TRUE,TRUE,0);
  vscrollbar=gtk_vscrollbar_new (GTK_TEXT(textbox)->vadj);
  gtk_box_pack_start(GTK_BOX(hbox), vscrollbar, FALSE, FALSE, 0);
  gtk_widget_show (vscrollbar);

  gtk_text_insert(GTK_TEXT(textbox),NULL,NULL,
                  NULL,(char *)get_information(data),-1);
  frame=gtk_frame_new(NULL);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),frame,
                     FALSE,FALSE,0);
  
  frame_vbox=gtk_vbox_new(FALSE,0);
  gtk_container_add(GTK_CONTAINER(frame),frame_vbox);

  label=gtk_label_new(contact);
  gtk_box_pack_start(GTK_BOX(frame_vbox),label,FALSE,FALSE,0);
  
  more_info=gtk_button_new_with_label("Detailed Information");
  gtk_button_set_relief(GTK_BUTTON(more_info),GTK_RELIEF_NONE);
  gtk_signal_connect(GTK_OBJECT (more_info), "clicked",
							GTK_SIGNAL_FUNC (more_info_button_clicked),
							data);
  
  gtk_box_pack_start(GTK_BOX(frame_vbox),more_info,FALSE,FALSE,0);
  
  /* connect signal to buttons*/
  gtk_signal_connect(GTK_OBJECT(stop_button), "clicked", 
							GTK_SIGNAL_FUNC(stop_button_clicked), 
							GTK_DIALOG(dialog)->action_area);
  
  gtk_signal_connect(GTK_OBJECT(play_button), "clicked", 
							GTK_SIGNAL_FUNC(play_button_clicked), 
							dialog);
  
  if( pthread_mutex_trylock(&playingLock)==EBUSY )
	 videoPlaying=1;
  else{
	 pthread_mutex_unlock(&playingLock);
	 videoPlaying=0;
  }
  
  if( flag || videoPlaying ){
	 
	 if(videoPlaying){
		gtk_widget_set_state( stop_button,GTK_STATE_INSENSITIVE );
		gtk_widget_set_state( play_button,GTK_STATE_INSENSITIVE );
		gtk_widget_set_state( zoom_checkbox,GTK_STATE_INSENSITIVE );
		gtk_widget_set_state( video_checkbox,GTK_STATE_INSENSITIVE );
		gtk_widget_set_state( audio_checkbox,GTK_STATE_INSENSITIVE );
	 }
	 if(flag){
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(audio_checkbox),FALSE);
		gtk_widget_set_state( audio_checkbox,GTK_STATE_INSENSITIVE );
	 }
  }
  
  
  gtk_widget_set_sensitive(GTK_WIDGET(mpegVideoCLIST),FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(otherVideoCLIST),FALSE);
  return dialog;
}


static void 
dismiss_button_clicked(GtkWidget *w,gpointer data){
  
  gtk_widget_set_sensitive(GTK_WIDGET(mpegVideoCLIST),TRUE);
  gtk_widget_set_sensitive(GTK_WIDGET(otherVideoCLIST),TRUE);
  gtk_widget_destroy(data);
  
}


char *get_information(char *data){
  char *info;
  char *temp;
  
  /* quickie to get the info */
  temp=(char *)strdup(data);
  temp=(char *)strtok(temp,"=\n");
  temp=(char *)strtok(NULL,"=\n");
  while(temp!=NULL){
    if( strcmp(temp,"i")==0 ){
      info=(char *)strtok(NULL,"=\n");
      break;
    }
    temp=(char *)strtok(NULL,"=\n");
  }
  return info;
}






