/**********************************************************************
 *
 * $Id: play_button_clicked.c,v 1.4 2000/05/03 23:31:50 htran Exp $
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 **********************************************************************/

#include <pthread.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include "lists.h"
#include "signal_callbacks.h"
#include "../mim/arguments.h"
#include "../mim/listeners.h"
#include "../mim/uTypes.h"


static int 
parse_sdp_data(args_t *a, char *data);

static int 
show_arguments(const args_t *a);

void play_button_clicked(GtkWidget *w,gpointer data){  
  /* this is essentially the main() in mim.c */
  int i=0;
  
  GtkWidget *dialog=data;
  GtkWidget *action_area=GTK_DIALOG(dialog)->action_area;
  GList *children=0;
  GList *cursor=0;
  
  extern pthread_t videoThread, audioThread;
  extern node *mpegListHead, *otherListHead;
  extern args_t arguments;
  
  char *name=NULL;
  node *this_entry=NULL;
  char formatIsMPEG=1;
  
  
  gtk_label_get(GTK_LABEL((gtk_container_children(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox)))->data) ,&name);
  
  
  
  
  if( (this_entry=find_node_byname(mpegListHead, name))==NULL ){
	 this_entry=find_node_byname(otherListHead, name);
	 formatIsMPEG=0;
  }
  
  parse_sdp_data(&arguments,this_entry->data);
  
  //show_arguments(&arguments);
  /************************************************************
	* At this point, have vAddr,vPort, aAddr,aPort, zoom is false
	* Need to check against checkboxes as well as arguments.playVideo && 
	* arguments.playAudio 
	************************************************************/
  
  children=gtk_container_children(GTK_CONTAINER(action_area));
  
  for(cursor=children,i=0; cursor!=NULL ;cursor=cursor->next,i++){
	 switch(i){
	 case 3:
		if( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(cursor->data)) ){
		  arguments.playAudio=1;
		}
		else
		  arguments.playAudio=0;
		
		break;
	 case 4:
		if( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(cursor->data)) ){
		  arguments.playVideo=true;
		}
		else
		  arguments.playVideo=0;
		break;
	 case 5:
		if( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(cursor->data)) ){
		  arguments.zoom=1;
		}
		break;
	 default:
		;
	 }
	 if(i!=1)
		gtk_widget_set_state(GTK_WIDGET(cursor->data),GTK_STATE_INSENSITIVE);
  }

  //show_arguments(&arguments);

  if(arguments.playVideo){
	 pthread_create(&videoThread,NULL,(void *)rtp_video_listener,&arguments);
  }
  
  if(arguments.playAudio){
	 pthread_create(&audioThread,NULL,(void *)rtp_audio_listener,&arguments);
  }
  
  
  
}


static int 
parse_sdp_data(args_t *a, char *data){
  
  char *dup=NULL;
  char *tmp=NULL;
  char *tmpVP=NULL;
  char *tmpVA=NULL;
  char *tmpAP=NULL;
  char *tmpAA=NULL;  
  
  a->sdpFile=(char *)malloc(strlen("NONE"));
  strcpy(a->sdpFile,"NONE");
  
  memset(a->videoAddress,0,16);
  memset(a->audioAddress,0,16);
  a->videoPort=-1;
  a->audioPort=-1;
  a->playVideo=false;
  a->playAudio=false;
  a->zoom=false;
  
  
  /* dup and parse the dup */
  dup=(char *)strdup(data);
  tmp=(char *)strtok(dup,"=\n");
  tmp=(char *)strtok(NULL,"=\n");
  while( tmp!=NULL ){
	 if( strcmp(tmp,"m")==0 ){	  // found media tag
		tmp=(char *)strtok(NULL,"=\n");
		if( (char *)strstr(tmp,"video")!=NULL ){	//found video tag
		  tmpVP=(char *)strdup(tmp);
		  tmpVA=(char *)strtok(NULL,"=\n");
		  tmpVA=(char *)strtok(NULL,"=\n");
		  a->playVideo=true;
		}
		else if ( (char *)strstr(tmp,"audio")!=NULL ){	//found audio tag
		  tmpAP=(char *)strdup(tmp);
		  tmpAA=(char *)strtok(NULL,"=\n");
		  tmpAA=(char *)strtok(NULL,"=\n");
		  a->playAudio=true;
		} 
	 }
	 
	 tmp=(char *)strtok(NULL,"=\n");
  }
  
  /* found all 4 pieces of information, pack them into the args struct */
  tmp=(char *)strtok(tmpVP," ");
  tmp=(char *)strtok(NULL," ");
  a->videoPort=atoi(tmp);

  
  
  tmp=(char *)strtok(tmpAP," ");
  tmp=(char *)strtok(NULL," ");
  a->audioPort=atoi(tmp);

  
  tmp=(char *)strtok(tmpVA," ");
  tmp=(char *)strtok(NULL," ");
  tmp=(char *)strtok(NULL," ");
  tmp=(char *)strtok(tmp,"/");
  strcpy(a->videoAddress,tmp);
  
  tmp=(char *)strtok(tmpAA," ");
  tmp=(char *)strtok(NULL," ");
  tmp=(char *)strtok(NULL," ");
  tmp=(char *)strtok(tmp,"/");
  strcpy(a->audioAddress,tmp);
  //done  
  return 1;
}

static int 
show_arguments(const args_t *a){
  fprintf(stderr,"[SHOW_ARGUMENTS]\n");
  fprintf(stderr,"videoAddress set to: %s %d\n",
			 (a->videoAddress!=NULL) ? a->videoAddress:"NULL",a->videoPort);
  fprintf(stderr,"audioAddress set to: %s %d\n",
			 (a->audioAddress!=NULL) ? a->audioAddress:"NULL", a->audioPort);
  fprintf(stderr,"sdpFile set to: %s\n",
			 (a->sdpFile!=NULL) ? a->sdpFile : "NULL");
  fprintf(stderr,"Video is %s\n", (a->playVideo)?"ON":"OFF");
  fprintf(stderr,"Audio is %s\n", (a->playAudio)?"ON":"OFF");
  fprintf(stderr,"Zoom is %s\n\n", (a->zoom)?"ON":"OFF");
  return 1; 
}
